let var npigeons pigeon hole =
  npigeons*hole+pigeon+1


let print_var out npigeons pigeon hole = out (string_of_int (var npigeons pigeon hole))


let print_beginning out npigeons =
  out "p cnf "; out (string_of_int (npigeons * npigeons));
  out " "; out (string_of_int (npigeons*((npigeons-1)*(npigeons-1)-((npigeons-2)*(npigeons-1)/2)+1)))


let print_instance out npigeons =
  (* At most one pigeon a hole *)
  for hole = 0 to npigeons-1 do
    for pigeon1 = 0 to npigeons-2 do
      for pigeon2 = pigeon1+1 to npigeons-1 do
        out "\n-";
        print_var out npigeons pigeon1 hole;
        out" -";
        print_var out npigeons pigeon2 hole;
        out " 0"
      done
    done
  done;

  (* Every pigeon must be in a hole *)
  for pigeon = 0 to npigeons-1 do
    out "\n";
    print_var out npigeons pigeon 0;
    for hole = 1 to npigeons-1 do
      out " ";
      print_var out npigeons pigeon hole
    done;
    out " 0"
  done


let pigeon output_name npigeons =
  let output = open_out output_name in
  let out_ref = ref 0 in
  let out s = output_string output s; incr out_ref; if !out_ref > 999 then (out_ref := 0; flush output) in

  print_beginning out npigeons;
  print_instance out npigeons


let _ = pigeon Sys.argv.(1) (int_of_string Sys.argv.(2))
