Require Import LargePrime PocklingtonRefl.

Set Virtual Machine.
Open Local Scope positive_scope.


Theorem large_prime_is_prime : prime (Zpos large_prime).
Proof.
 apply (Pocklington_refl
         (Pock_certif large_prime 2 ((65982793, 1)::(15698303, 1)::(140977, 1)::(16843, 1)::(3, 1)::(2,2)::nil) 32196881222741425638167427)
        ((Pock_certif 65982793 5 ((2749283, 1)::(2,3)::nil) 1) ::
         (Pock_certif 15698303 5 ((269, 1)::(2,1)::nil) 126) ::
         (Pock_certif 2749283 2 ((59, 1)::(2,1)::nil) 168) ::
         (Pock_certif 140977 5 ((3, 1)::(2,4)::nil) 54) ::
         (Proof_certif 16843 prime16843) ::
         (Proof_certif 269 prime269) ::
         (Proof_certif 59 prime59) ::
         (Proof_certif 3 prime3) ::
         (Proof_certif 2 prime2) ::
          nil)).
 exact_no_check (refl_equal true).
Qed.


Theorem old_large_prime_was_prime : prime (Zpos old_large_prime).
Proof.
 apply (Pocklington_refl
         (Pock_certif old_large_prime 3 ((5994341377, 1)::(1033337, 1)::(71693, 1)::(641, 1)::(7, 1)::(3, 2)::(2,1)::nil) 56841713413106755238159798)
        ((Pock_certif 5994341377 5 ((3, 1)::(2,10)::nil) 3634) ::
         (Pock_certif 1033337 3 ((37, 1)::(2,3)::nil) 530) ::
         (Pock_certif 71693 2 ((17923, 1)::(2,2)::nil) 1) ::
         (Proof_certif 17923 prime17923) ::
         (Proof_certif 641 prime641) ::
         (Proof_certif 37 prime37) ::
         (Proof_certif 7 prime7) ::
         (Proof_certif 3 prime3) ::
         (Proof_certif 2 prime2) ::
          nil)).
 exact_no_check (refl_equal true).
Qed.
