{ stdenv, fetchgit, which, coq }:

stdenv.mkDerivation {

  name = "coq${coq.coq-version}-ppsimpl-8.4";

  src = fetchgit {
    url = https://gforge.inria.fr/git/ppsimpl/ppsimpl.git;
    rev = "b9472cb3a7f9675010913f6293742e3ebc4c2a8b";
    sha256 = "0p2d3aw2cvz1yiy03vq0vv84mczn28hb7ivh2a5sd0qrsl9l595r";
  };

  buildInputs = [ which coq coq.ocaml coq.camlp5 ];

  installFlags = "COQLIB=$(out)/lib/coq/${coq.coq-version}/";

}
